﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Olap;
using Infragistics.Olap.FlatData;

namespace PivotGridMetadata
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            DataSourceBase.RegisterResources("PivotGridMetadata.Resources.OlapResourceStrings", typeof(MainWindow).Assembly);
            FlatDataSource.RegisterResources("PivotGridMetadata.Resources.OlapFlatDataResourceStrings", typeof(MainWindow).Assembly);

            InitializeComponent();
            this.Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            SalesDataSample data = new SalesDataSample();
            FlatDataSource fds = new FlatDataSource();
            fds.ItemsSource = data;
            fds.Cube = FlatDataSource.GenerateInitialCube("Sales Data");

            CubeMetadata cubeMetadata = new CubeMetadata();
            cubeMetadata.DisplayName = "Dados";
            cubeMetadata.DataTypeFullName = typeof(Sale).FullName;

            cubeMetadata.DimensionSettings.Add(new DimensionMetadata()
            {
                SourcePropertyName = "AmountOfSale",
                DisplayName = "[Translation]Amount of sale",
                DisplayFormat = "{0:C2}",
                DimensionType = DimensionType.Measure,
            });
            cubeMetadata.DimensionSettings.Add(new DimensionMetadata()
            {
                SourcePropertyName = "NumberOfUnits",
                DisplayName = "[Translation]Units sold",
                DimensionType = DimensionType.Measure,
            });

            cubeMetadata.DimensionSettings.Add(new DimensionMetadata()
            {
                SourcePropertyName = "Product",
                DisplayName = "[Translation]Product",
            });

            fds.CubesSettings.Add(cubeMetadata);

            pivotGrid.DataSource = fds;
            pivotDataSelector.DataSource = fds;
        }
    }
}
